 attribute vec4 aPosition;
 attribute vec4 aTextureCoord;

 const int GAUSSIAN_SAMPLES = 9;

 uniform float texelWidthOffset;
 uniform float texelHeightOffset;

 varying vec2 textureCoordinate;
 varying vec2 blurCoordinates[GAUSSIAN_SAMPLES];
 varying vec2 singleStepOffset;

// varying mediump vec2 centerTextureCoordinate;
//  varying mediump vec2 oneStepLeftTextureCoordinate;
//  varying mediump vec2 twoStepsLeftTextureCoordinate;
//  varying mediump vec2 oneStepRightTextureCoordinate;
//  varying mediump vec2 twoStepsRightTextureCoordinate;

 void main()
 {
     gl_Position = aPosition;
     textureCoordinate = aTextureCoord.xy;

     // Calculate the positions for the blur
     int multiplier = 0;
     vec2 blurStep;
     singleStepOffset = vec2(texelWidthOffset, texelHeightOffset);
     for (int i = 0; i < GAUSSIAN_SAMPLES; i++)
     {
         multiplier = (i - ((GAUSSIAN_SAMPLES - 1) / 2));
         // Blur in x (horizontal)
         blurStep = float(multiplier) * singleStepOffset;
         blurCoordinates[i] = aTextureCoord.xy + blurStep;
     }

// vec2 firstOffset = vec2(1.3846153846 * texelWidthOffset, 1.3846153846 * texelHeightOffset);
//     vec2 secondOffset = vec2(3.2307692308 * texelWidthOffset, 3.2307692308 * texelHeightOffset);
//
//     centerTextureCoordinate = textureCoordinate;
//          oneStepLeftTextureCoordinate = textureCoordinate - firstOffset;
//          twoStepsLeftTextureCoordinate = textureCoordinate - secondOffset;
//          oneStepRightTextureCoordinate = textureCoordinate + firstOffset;
//          twoStepsRightTextureCoordinate = textureCoordinate + secondOffset;
 }