uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture1;
varying highp vec2 textureCoordinate;

void main(){
    vec2 maskCoord = vec2(textureCoordinate.x, textureCoordinate.y);
    highp vec4 maskColor = texture2D(inputImageTexture1, maskCoord);
    float a = smoothstep(0.1, 0.9, maskColor.r);

    highp vec4 bgColor;
    bool isMask = (maskColor.r + maskColor.g + maskColor.b) >= 1.0;
    bool isEdge = a > 0.0 && a < 1.0;

    vec4 icolor = texture2D(inputImageTexture, textureCoordinate);

    if(isMask || isEdge){
         gl_FragColor = vec4(1.0, 0, 0, 0.0);
    }else{
          if(icolor == vec4(0.0, 0, 0, 1.0)){
                gl_FragColor = vec4(1.0, 0, 0, 0.0);
            }else{
                if(icolor.a > 0.95){
                    gl_FragColor = vec4(0, 0, 1.0, 0.0);
                }else{
                    gl_FragColor = icolor;
                }
            }
    }
}