precision highp float;
uniform sampler2D inputImageTexture;
uniform int useOriginal;
uniform float alphaFactor;
uniform mat4 rotateMatrix;
varying vec4 baseColor;


void main()
{
    vec4 rawCoordinate = vec4(gl_PointCoord.x, 1.0 - gl_PointCoord.y, 0, 1);
    vec4 rotatedCoordinate = rotateMatrix * rawCoordinate;
    vec2 textureCoord = vec2(rotatedCoordinate.x, rotatedCoordinate.y);
//    vec2 textureCoord = vec2(gl_PointCoord.x, 1.0 - gl_PointCoord.y);
    vec3 rgbColor = baseColor.xyz;
    vec4 sampleData = texture2D( inputImageTexture, textureCoord );

    if(sampleData.a != 0.0){
//        float sampley = 0.299*sampleData.r + 0.587*sampleData.g + 0.114*sampleData.b;
//        float sampleu = (sampleData.b - sampley)*0.565;
//        float samplev = (sampleData.r - sampley)*0.713;
//
        float yelem = 0.299*rgbColor.r + 0.587*rgbColor.g + 0.114*rgbColor.b;
        float uelem = (rgbColor.b - yelem)*0.565;
        float velem = (rgbColor.r - yelem)*0.713;


        yelem = (yelem*255.0 - 160.0)/(255.0 - 160.0)*0.7 + 0.3;
        if(yelem < 0.0){
            yelem = 0.3;
        }
//
//        float dsty = yelem;
//        float dstu = sampleu/0.5 * uelem * 8.0;
//        float dstv = samplev/0.5 * velem * 8.0;


//        sampleData = baseColor;
//        float factor = 2.5*weight;
//        if(factor > 1.0){
//            factor = 1.0;
//        }
//        yelem *= factor;
//
//        rgbColor.r = dsty + 1.403*dstv;
//        rgbColor.g = dsty - 0.344*dstu-0.714*dstv;
//        rgbColor.b = dsty + 1.770*dstu;
//
//         rgbColor.r = yelem + 1.403*velem;
//         rgbColor.g = yelem - 0.344*uelem-0.714*velem;
//         rgbColor.b = yelem + 1.770*uelem;

         if(useOriginal > 0){
            gl_FragColor = vec4(sampleData.xyz, baseColor.a * sampleData.a);
         }else{
            gl_FragColor = vec4(rgbColor.xyz, yelem * sampleData.a * alphaFactor);
            //gl_FragColor = vec4(baseColor.xyz, baseColor.a * sampleData.a);
         }
         //gl_FragColor = vec4(rgbColor, yelem*sampleData.a);
    }else{
        //gl_FragColor = vec4(sampleData.a*rgbColor, sampleData.a);
        gl_FragColor = vec4(1.0, rgbColor.y, rgbColor.z, 0.0);
    }
}