#extension GL_OES_EGL_image_external : require

uniform sampler2D s_texture;

precision highp float;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture1;
varying highp vec2 textureCoordinate;

void main()
{
    vec2 maskCoord = vec2(textureCoordinate.x, textureCoordinate.y);

    highp vec4 camColor = texture2D(inputImageTexture, textureCoordinate);
    highp vec4 maskColor = texture2D(inputImageTexture1, maskCoord);
    float a = smoothstep(0.1, 0.9, maskColor.r);

    highp vec4 normal;
    highp vec3 bgMix;
    highp vec4 bgColor;
    bool isMask = (maskColor.r + maskColor.g + maskColor.b) >= 1.0;
    bool isStroke = maskColor.r >= 1.0 && maskColor.g == 0.0 && maskColor.b == 0.0;
    bgMix = mix(camColor.rgb, bgColor.rgb, bgColor.a);
    normal.rgb = mix(bgMix, camColor.rgb, maskColor.a);
    normal.a = 1.0;
    bool isEdge = a > 0.0f && a < 1.0f;

  if(isEdge){
          bgColor = camColor;
      }else{
        if(isMask){
            bgColor = normal;
          }else{
            bgColor = camColor;
          }
      }
    gl_FragColor = bgColor;
}